<div *ngIf="paymentJournals && paymentJournals.length > 0">
  <br>
  <span class="badge badge-primary">Transaction Journals</span>
  <div class="row">
    <div class="col-12 table-responsive">
      <p-table id="exportTable"
               class="text-center"
               [columns]="columnName"
               [value]="(paymentJournals)"
               [resizableColumns]="true"
               [autoLayout]="true">

        <ng-template pTemplate="caption">
          List of Payment Journals
          :&nbsp;{{ paymentJournals.length }}
          <button type="button"
                  pButton pRipple
                  icon="pi pi-file-excel"
                  (click)="exportExcel()"
                  class="p-button-success p-mr-2"
                  pTooltip="XLS"
                  tooltipPosition="bottom"></button>
        </ng-template>
        <ng-template pTemplate="header" let-columns>
          <tr>
            <th *ngFor="let col of columns" [pSortableColumn]="col.value">
              {{col.name}}
              <p-sortIcon [field]="col.value"></p-sortIcon>
            </th>
          </tr>
        </ng-template>

        <ng-template pTemplate="body" let-list let-i="rowIndex">
          <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
            <td>{{ i + 1 }}</td>
            <td>{{ list.transactionDate | date:'MMM d, y, h:mm:ss a' }}</td>
            <td>{{ list.cbsTxnId }}</td>
            <td>
              <a (click)="showDetail(list)"><u>{{ list.fromAccountId}}</u></a>
              <app-dynamic-dialog
                [popupType]="'account-detail'"
                [accountNumber]="list.fromAccountId"
              ></app-dynamic-dialog>
              <br>
              <hr>
              <span style="color: red">{{list.debitRemarks}}</span>
            </td>
            <td>{{ list.toAccountId}}
              <app-dynamic-dialog
                [popupType]="'account-detail'"
                [accountNumber]="list.toAccountId"
              ></app-dynamic-dialog>
              <br>
              <hr>
              <span style="color: red">{{list.creditRemarks}}</span>
            </td>
            <td>{{ list.amount | currency: 'NPR. '}} <br><hr>
              <span style="color: red">{{list.remarks}}</span>
            </td>
            <td>{{ list.fromBranch.name + ' ( ' + list.fromBranch.code + ' )' }}</td>
            <td>{{ list.toBranch.name + ' ( ' + list.toBranch.code + ' )'}}</td>
            <td>{{ list.attempts}}</td>
            <td>{{ list.status}}</td>
            <td>
              <button class="btn btn-success btn-xs"
                      (click)="Reprocess(list)" *ngIf="list.status != 'PAID'">
                <i class="pi pi-replay" title="Reprocess Txn"></i>
              </button>
              <button class="btn btn-primary btn-xs"
                      *ngIf="list.status != 'PAID'" (click)="updateStatus(list)">
                <i class="pi pi-directions" title="Update Status"></i>
              </button>
              &nbsp;<button class="btn btn-info btn-xs"
                            *ngIf="list.status != 'PAID'" (click)="updateRemarks(list)">
              <i class="pi pi-eye" title="View Narration"></i>
            </button>
            </td>
          </tr>
        </ng-template>
      </p-table>
    </div>
    <!-- /.col -->
  </div>
</div>

<p-dialog [(visible)]="display"
          [style]="{width: '20vw'}"
          *ngIf="detail">
  <p-header style="color: red">
    Addition Transaction Detail ?
  </p-header>
  <p>Remarks:: <span class="strong">{{detail.remarks}}</span>
  </p>
  <p *ngIf="detail.responseMessage">
    Response Message:: <span class="strong">{{detail.responseMessage}}</span>
  </p>
</p-dialog>

<p-dialog [(visible)]="displayUpdateStatus" [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Confirmation Page, Do you want to Update Status ?
  </p-header>
  <form [formGroup]="updateStatusForm" (ngSubmit)="onSubmit()">
    <div class="form-group">
      <label for="status">Status</label>
      <select id="status"
              class="form-control"
              formControlName="status"
              [ngClass]="{ 'is-invalid': submitted && f.status.errors }"
              name="status"
              required
      >
        <option *ngFor="let event of (status); let i = index"
                [ngValue]="(status)[i]"
        >{{ (status)[i] }}</option>
      </select>
      <div *ngIf="submitted && f.status.errors" class="invalid-feedback">
        <div *ngIf="f.status.errors.required">Status is required</div>
      </div>
    </div>
    <div class="form-group">
      <label for="detail">Comments<span class="required">*</span></label>
      <textarea class="form-control"
                rows="3"
                id="detail"
                formControlName="comments"
                [ngClass]="{ 'is-invalid': submitted && f.comments.errors }"
                placeholder="Enter Expense Detail (Min: 10 , Max 500 Characters)"
                required
      >
        <div *ngIf="submitted && f.comments.errors" class="invalid-feedback">
          <div *ngIf="f.comments.errors.required">Comment is Required.</div>
        </div>
      </textarea>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  type="button"
                  [disabled]="loading"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block" (click)="displayUpdateStatus=false">
            Cancel
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>


<p-dialog [(visible)]="displayViewUpdateNarrationForm" [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Confirmation Page, Do you want to Update Remarks ?
  </p-header>
  <form [formGroup]="viewUpdateRemarksForm" (ngSubmit)="onUpdateRemarksSubmit()">
    <div class="form-gr oup">
      <label for="detail">Remarks<span class="required">*</span></label>
      <textarea class="form-control"
                rows="1"
                id="remarks"
                name="remarks"
                formControlName="remarks"
                disabled="true"
                [ngClass]="{ 'is-invalid': submitted && ff.remarks.errors }"
                required
      >
        <div *ngIf="submitted && ff.remarks.errors" class="invalid-feedback">
          <div *ngIf="ff.remarks.errors.required">Remarks is Required.</div>
        </div>
      </textarea>
    </div>
    <div class="form-group">
      <label for="detail">Debit Remarks<span class="required">*</span></label>
      <textarea class="form-control"
                rows="2"
                id="debitRemarks"
                name="debitRemarks"
                formControlName="debitRemarks"
                [ngClass]="{ 'is-invalid': submitted && ff.debitRemarks.errors }"
                required
      >
        <div *ngIf="submitted && ff.debitRemarks.errors" class="invalid-feedback">
          <div *ngIf="ff.debitRemarks.errors.required">Debit Remarks is Required.</div>
        </div>
      </textarea>
    </div>
    <div class="form-group">
      <label for="detail">Credit Remarks<span class="required">*</span></label>
      <textarea class="form-control"
                rows="2"
                id="creditRemarks"
                name="creditRemarks"
                formControlName="creditRemarks"
                [ngClass]="{ 'is-invalid': submitted && ff.creditRemarks.errors }"
                required
      >
        <div *ngIf="submitted && ff.creditRemarks.errors" class="invalid-feedback">
          <div *ngIf="ff.creditRemarks.errors.required">Credit Remarks is Required.</div>
        </div>
      </textarea>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  type="button"
                  [disabled]="loading"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block" (click)="displayViewUpdateNarrationForm=false">
            Cancel
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>
